package org.apache.bcel.util;

package .tmp;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.util.Hashtable;
import org.apache.bcel.classfile.ClassParser;
import org.apache.bcel.classfile.ConstantClass;
import org.apache.bcel.classfile.ConstantPool;
import org.apache.bcel.classfile.ConstantUtf8;
import org.apache.bcel.classfile.JavaClass;
import org.apache.bcel.classfile.Utility;
import org.apache.bcel.util.ClassLoaderRepository;
import org.apache.bcel.util.Repository;
import org.apache.bcel.util.SyntheticRepository;

@Deprecated
public class ClassLoader extends ClassLoader {
  private static final String BCEL_TOKEN = "$$BCEL$$";
  
  public static final String[] DEFAULT_IGNORED_PACKAGES = new String[] { "java.", "javax.", "sun." };
  
  private final Hashtable<String, Class<?>> classes = new Hashtable<>();
  
  private final String[] ignoredPackages;
  
  private Repository repository = SyntheticRepository.getInstance();
  
  public ClassLoader() {
    this(DEFAULT_IGNORED_PACKAGES);
  }
  
  public ClassLoader(ClassLoader deferTo) {
    super(deferTo);
    this.ignoredPackages = DEFAULT_IGNORED_PACKAGES;
    this.repository = new ClassLoaderRepository(deferTo);
  }
  
  public ClassLoader(ClassLoader deferTo, String[] ignoredPackages) {
    this(ignoredPackages);
    this.repository = new ClassLoaderRepository(deferTo);
  }
  
  public ClassLoader(String[] ignoredPackages) {
    this.ignoredPackages = ignoredPackages;
  }
  
  protected JavaClass createClass(String className) {
    int index = className.indexOf("$$BCEL$$");
    String realName = className.substring(index + "$$BCEL$$".length());
    JavaClass clazz = null;
    try {
      byte[] bytes = Utility.decode(realName, true);
      ClassParser parser = new ClassParser(new ByteArrayInputStream(bytes), "foo");
      clazz = parser.parse();
    } catch (IOException e) {
      e.printStackTrace();
      return null;
    } 
    ConstantPool cp = clazz.getConstantPool();
    ConstantClass cl = (ConstantClass)cp.getConstant(clazz.getClassNameIndex(), (byte)7, ConstantClass.class);
    ConstantUtf8 name = cp.getConstantUtf8(cl.getNameIndex());
    name.setBytes(className.replace('.', '/'));
    return clazz;
  }
  
  protected Class<?> loadClass(String className, boolean resolve) throws ClassNotFoundException {
    Class<?> cl = null;
    if ((cl = this.classes.get(className)) == null) {
      for (String ignoredPackage : this.ignoredPackages) {
        if (className.startsWith(ignoredPackage)) {
          cl = getParent().loadClass(className);
          break;
        } 
      } 
      if (cl == null) {
        JavaClass clazz = null;
        if (className.contains("$$BCEL$$")) {
          clazz = createClass(className);
        } else {
          if ((clazz = this.repository.loadClass(className)) == null)
            throw new ClassNotFoundException(className); 
          clazz = modifyClass(clazz);
        } 
        if (clazz != null) {
          byte[] bytes = clazz.getBytes();
          cl = defineClass(className, bytes, 0, bytes.length);
        } else {
          cl = Class.forName(className);
        } 
      } 
      if (resolve)
        resolveClass(cl); 
    } 
    this.classes.put(className, cl);
    return cl;
  }
  
  protected JavaClass modifyClass(JavaClass clazz) {
    return clazz;
  }
}
